import { world, system } from '@minecraft/server'

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('v360:crystal_pot_placer', {
        onPlace({ block }) {
            const chance = Math.random()
            if (chance < 0.50) {
                if (chance <= 1 / 10) {
                    world.structureManager.place('mystructure:crystal_pot', block.dimension, block.location)
                }
                else if (chance <= 2 / 10) {
                    world.structureManager.place('mystructure:key_pot', block.dimension, block.location)
                }
                else if (chance <= 3 / 10) {
                    world.structureManager.place('mystructure:shard_pot', block.dimension, block.location)
                }
                else if (chance <= 4 / 10) {
                    world.structureManager.place('mystructure:torch_pot', block.dimension, block.location)
                }
                else if (chance <= 5 / 10) {
                    world.structureManager.place('mystructure:crystal_pot', block.dimension, block.location)
                }
                else if (chance <= 6 / 10) {
                    world.structureManager.place('mystructure:crystal_pot', block.dimension, block.location)
                }
                else if (chance <= 7 / 10) {
                    world.structureManager.place('mystructure:crystal_pot', block.dimension, block.location)
                }
                else if (chance <= 8 / 10) {
                    world.structureManager.place('mystructure:crystal_pot', block.dimension, block.location)
                }
                else if (chance <= 9 / 10) {
                    world.structureManager.place('mystructure:crystal_pot', block.dimension, block.location)
                }
                else {
                    world.structureManager.place('mystructure:crystal_pot', block.dimension, block.location)
                }
            }
            else {
                block.setType('air')
            }
        },
        onTick({ block }) {
            const chance = Math.random()
            if (chance < 0.50) {
                if (chance <= 1 / 10) {
                    world.structureManager.place('mystructure:crystal_pot', block.dimension, block.location)
                }
                else if (chance <= 2 / 10) {
                    world.structureManager.place('mystructure:key_pot', block.dimension, block.location)
                }
                else if (chance <= 3 / 10) {
                    world.structureManager.place('mystructure:shard_pot', block.dimension, block.location)
                }
                else if (chance <= 4 / 10) {
                    world.structureManager.place('mystructure:torch_pot', block.dimension, block.location)
                }
                else if (chance <= 5 / 10) {
                    world.structureManager.place('mystructure:crystal_pot', block.dimension, block.location)
                }
                else if (chance <= 6 / 10) {
                    world.structureManager.place('mystructure:crystal_pot', block.dimension, block.location)
                }
                else if (chance <= 7 / 10) {
                    world.structureManager.place('mystructure:crystal_pot', block.dimension, block.location)
                }
                else if (chance <= 8 / 10) {
                    world.structureManager.place('mystructure:crystal_pot', block.dimension, block.location)
                }
                else if (chance <= 9 / 10) {
                    world.structureManager.place('mystructure:crystal_pot', block.dimension, block.location)
                }
                else {
                    world.structureManager.place('mystructure:crystal_pot', block.dimension, block.location)
                }
            }
            else {
                block.setType('air')
            }
        }
    })
})

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('v360:crystal_golem_placer', {
        onPlace({ block }) {
            const chance = Math.random()
            block.setType('air')
            if (chance < 1 / 4) {
                block.dimension.spawnEntity('v360:amethyst_crystal_golem', block.bottomCenter()).triggerEvent('chance_key')
            }
            else if (chance < 2 / 4) {
                block.dimension.spawnEntity('v360:citrine_crystal_golem', block.bottomCenter()).triggerEvent('chance_key')
            }
            else if (chance < 3 / 4) {
                block.dimension.spawnEntity('v360:garnet_crystal_golem', block.bottomCenter()).triggerEvent('chance_key')
            }
            else if (chance < 4 / 4) {
                block.dimension.spawnEntity('v360:jade_crystal_golem', block.bottomCenter()).triggerEvent('chance_key')
            }
        },
        onTick({ block }) {
            const chance = Math.random()
            block.setType('air')
            if (chance < 1 / 4) {
                block.dimension.spawnEntity('v360:amethyst_crystal_golem', block.bottomCenter()).triggerEvent('chance_key')
            }
            else if (chance < 2 / 4) {
                block.dimension.spawnEntity('v360:citrine_crystal_golem', block.bottomCenter()).triggerEvent('chance_key')
            }
            else if (chance < 3 / 4) {
                block.dimension.spawnEntity('v360:garnet_crystal_golem', block.bottomCenter()).triggerEvent('chance_key')
            }
            else if (chance < 4 / 4) {
                block.dimension.spawnEntity('v360:jade_crystal_golem', block.bottomCenter()).triggerEvent('chance_key')
            }
        }
    })
})