import { world, system } from '@minecraft/server'

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('v360:rainbow_cluster', {
        onTick({ block }) {
            const chance = Math.random()
            if (chance < 0.1) {
                block.dimension.spawnParticle('v360:rainbow_cluster', block.center())
            }
        }
    })
})