import { world, system } from '@minecraft/server'

system.runInterval(() => {
    world.getDimension('overworld').getEntities().filter(
        (data) => {
            try {
                const { x, y, z } = data.location
                const location = data.dimension.getBlock({ x: x, y: y - 1, z: z })?.typeId === 'minecraft:bedrock'
                if (data.getComponent('type_family')?.hasTypeFamily('digging_woodlouse') && location) {
                    data.triggerEvent('dig_out_sad')
                }
            } catch { }
        }
    )
}, 2)

system.runInterval(() => {
    world.getDimension('nether').getEntities().filter(
        (data) => {
            try {
                const { x, y, z } = data.location
                const location = data.dimension.getBlock({ x: x, y: y - 1, z: z })?.typeId === 'minecraft:bedrock'
                if (data.getComponent('type_family')?.hasTypeFamily('digging_woodlouse') && location) {
                    data.triggerEvent('dig_out_sad')
                }
            } catch { }
        }
    )
}, 2)

system.runInterval(() => {
    world.getDimension('the_end').getEntities().filter(
        (data) => {
            try {
                const { x, y, z } = data.location
                const location = data.dimension.getBlock({ x: x, y: y - 1, z: z })?.typeId === 'minecraft:bedrock'
                if (data.getComponent('type_family')?.hasTypeFamily('digging_woodlouse') && location) {
                    data.triggerEvent('dig_out_sad')
                }
            } catch { }
        }
    )
}, 2)