import { world, system, ItemStack } from '@minecraft/server'

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('v360:amethyst_geode', {
        onTick({ block }) {
            const shard = new ItemStack('minecraft:amethyst_shard', 1)
            block.dimension.spawnItem(shard, block.center())
        }
    })
})

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('v360:citrine_geode', {
        onTick({ block }) {
            const shard = new ItemStack('v360:citrine_shard', 1)
            block.dimension.spawnItem(shard, block.center())
        }
    })
})

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('v360:garnet_geode', {
        onTick({ block }) {
            const shard = new ItemStack('v360:garnet_shard', 1)
            block.dimension.spawnItem(shard, block.center())
        }
    })
})

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('v360:jade_geode', {
        onTick({ block }) {
            const shard = new ItemStack('v360:jade_shard', 1)
            block.dimension.spawnItem(shard, block.center())
        }
    })
})