import { world, system } from '@minecraft/server'

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('v360:glowbloom', {
        onTick({ block }) {
            const { x, y, z } = block.location
            block.dimension.spawnParticle('v360:glowbloom', { x: x + 0.5, y: y - 0.5, z: z + 0.5 })
        }
    })
})