import { world, system } from '@minecraft/server'

world.afterEvents.projectileHitEntity.subscribe(data => {
    const target = data.getEntityHit().entity
    const arrow = data.projectile
    const { x, y, z } = target.location
    if (arrow?.typeId === 'v360:jade_arrow') {
        try {
            target.dimension.getEntities({ location: target.location, maxDistance: 3 }).forEach(
                (data) => {
                    data.applyDamage(2)
                }
            )
            target.dimension.spawnParticle('v360:jade_arrow', { x: x, y: y + 1, z: z })
        } catch { }
    }
})