import { system, world } from '@minecraft/server';

const endAdventure = [
    'v360:record_beautiful_cave'
]

world.afterEvents.itemUseOn.subscribe(evd => {
    const { source, itemStack, block } = evd;

    if (!block.permutation.matches('minecraft:jukebox')) return;

    if (itemStack) {
        if (endAdventure.includes(itemStack.typeId)) {
            system.run(function () {
                block.dimension.playSound("record.beautiful_cave", block.location)
                source.runCommand(`title @a[r=10] actionbar §dNow playing: Steve Rybakov - Beautiful Cave`);
            })
            return;
        }
    }
    system.run(function () {
        source.runCommand(`stopsound @a record.beautiful_cave`)
    })
})
