import { world, system, ItemStack } from '@minecraft/server'

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('v360:rooted_root_cave_dirt', {
        onPlayerInteract({ block, player }) {
            const selectedItem = player.getComponent('equippable').getEquipment('Mainhand')
            if (selectedItem?.hasTag('minecraft:is_hoe')) {
                block.dimension.spawnItem(new ItemStack('minecraft:hanging_roots', 1), block.center())
                block.setType('v360:root_cave_dirt')
            }
        }
    })
})